use utf8;

my $legacy = do 'mplayer.eng.inc.pl' or die $@;

{
key => { %{ $legacy->{key} },
	',' => "step backward<>s",
	'Q' => "save and quit",
	'_' => "cycle video tr<>ack<>s",
	'+' => "audio delay +<>.1s", # +ctrl in mpv
	'-' => "audio delay -<>.1s", # +ctrl in mpv
	'o' => "osd state switch",
	'O' => "osd mode toggle",
	'd' => "deint<>erlace",
	'j' => "next sub<>title",
	'J' => "prev<>ious sub<>title",
	'A' => "aspect override",
	'u' => "subtitle style",
	'V' => "subtitle aspect",
	'l' => "A-B loop",
	'L' => "infinite looping",
	'S' => "record screen<>shot<>s\n-vf screenshot", # mpv?
	'^s'=> "actual screen<>shot",
	'5' => "gamma decrease",
	'6' => "gamma increase",
},

mode => $legacy->{mode},

flag => { %{ $legacy->{flag} },
	new => ["mpv"      => "Introduced in <em>mpv</em>, not supported in original MPlayer"],
},

def => {
	'' => { %{ $legacy->{def}->{''} },
		'b' => undef,
		'g' => undef,
		'y' => undef,
		'F' => undef,
		'a' => undef,
		'c' => undef,
		'n' => undef,
		'I' => undef,
		',' => 'g7 new',
		'_' => 'g4 new',
		'Q' => 'g9 new',
		'O' => 'g1 new',
		'P' => '=o new',
		'J' => 'g2 new',
		'A' => 'g4 new',
		'u' => 'g2 new',
		'V' => 'g2 new',
		'l' => 'g7 new',
		'L' => 'g7 new',
		'^s'=> 'g9 ext new',
	},
},
}
