class WordMultiChoice extends WordQuiz {
	next() {
		let word = this.words.shift();
		let form = put(this.form,
			'+img[src=$]+ul', `/data/word/en/${word[2]}.jpg`,
		);

		let answers = [word[0], this.words[0][0], this.words[1][0], this.words[2][0]]
			.shuffle()
		answers.forEach(suggest => {
			let label = suggest.replace(/\/.*/, '');
			let option = put(form, 'li', label, {onclick: () => {
				if (suggest != word[0]) {
					// incorrect
					put(option, '.wrong');
					return;
				}
				put(option, '.good');
				window.setTimeout(() => this.next(), 500);
			}});
		});
	}

	setup() {
		this.form = document.getElementById('quiz');
		this.next();
	}
};
